#include "C:\Program Files (x86)\AutoIt3\Include\Array.au3"
#include "C:\Program Files (x86)\AutoIt3\Include\File.au3"
#include "C:\Program Files (x86)\AutoIt3\Include\MsgBoxConstants.au3"

; ConsoleWrite (StringReplace((StringReplace("U:\Andersdoen\NAAR MENGWERK\Test Project\Aflevering 1\Audionabewerking","NAAR MENGWERK\","")), "U:", "D:"))
; Script to check if destination directory exist with use of the source path of the ftp. We reconstruct the source path to the destination path and do the check.
; On Error code 0 the nodestructure in ffastrans continues. Error code 1
; Bronstructuur is Drive/Klant/NAAR MENGWERK/Project/
; Doelstructuur is Drive/10 PROJECTS/Project/000 Aangeleverd
; $Cmdline is input. Dit moet de inputfolderstructuur zijn zonder bestandsnaam.
; We voegen elke subfolder toe aan een array zodat we op een andere manier kunnen samenstellen.

; For Testing without input
; $Cmdline = "U:\Andersdoen\NAAR MENGWERK\Test Project\Aflevering 1\Audionabewerking"


; Local Variables
Local $sDestinationDrive = "D:\10 PROJECTS\"
Local $sDestiantionFolders
Local $sDestinationConstruct


Local $aSourceFolders = StringSplit($Cmdline[1], "\")
    If @error = 1 Then
        ConsoleWrite($MB_SYSTEMMODAL, "", "Path was invalid.")
    EndIf
    ; Display the results returned by _FileListToArray.
    ; _ArrayDisplay($aSourceFolders, "$aSourceFolders")



; Construct Destination Folder
$sDestinationConstruct = _ArrayToString($aSourceFolders,"\", 2, 2) & "\" & _ArrayToString($aSourceFolders,"\", 4, 4) & "\"
$sDestinationFolders = $sDestinationDrive & $sDestinationConstruct
; ConsoleWrite ($sDestinationFolders)



; Check if folder exists and then cancel or continue de ffastrans worfklow
IF FileExists ($sDestinationFolders) Then
   ConsoleWrite("Destination folder is the same as the source as defined")
   ; Exit(0) ; Do not exit here also check if file has finished growing.
Else
   ConsoleWrite("Destination folder is NOT the same as the source as defined, workflow is cancelled")
   Exit(1)
EndIf

; ====== AND NOW CHECK IF FILE HAS FINISHED GROWING =======

If Ubound($CmdLine) < 2  Then
    ConsoleWrite("This program checks and waits for a given File to be opened for appending (write access check). Please provide a valid full path to an existing file as first and only parameter"&@CRLF)
    exit(1)
EndIf
If FileExists($CmdLine[1]) Then
    ;just go on
Else
    ConsoleWrite("The file "&$CmdLine[1]&" doesn not exist. Please provide a valid full path to an existing file as first and only parameter"&@CRLF)
    exit(1)
EndIf
    
While (1)
    ConsoleWrite("Trying to open"&$CmdLine[1]&@CRLF)
    Local $hFileOpen = FileOpen ( $CmdLine[1] ,1) ;open for appending
    If $hFileOpen = -1 Then
        ConsoleWrite("File not yet ready"&@CRLF)
        sleep(5000)
        ContinueLoop 
    EndIf
    FileClose($hFileOpen);
    ExitLoop
WEnd
ConsoleWrite($CmdLine[1] & " could successfully be opened for appending"&@CRLF)
